"""
Django settings for smartcities_bigdata project.

Generated by 'django-admin startproject' using Django 3.1.7.

For more information on this file, see
https://docs.djangoproject.com/en/3.1/topics/settings/

For the full list of settings and their values, see
https://docs.djangoproject.com/en/3.1/ref/settings/
"""

from pathlib import Path
import os

# Build paths inside the project like this: BASE_DIR / 'subdir'.
BASE_DIR = Path(__file__).resolve().parent.parent


# Quick-start development settings - unsuitable for production
# See https://docs.djangoproject.com/en/3.1/howto/deployment/checklist/

# SECURITY WARNING: keep the secret key used in production secret!
SECRET_KEY = os.getenv('SECRET_KEY', 'x55chli2=u*ero5ts%ouo)hh*#$sj8!*(ns=dv15g=hk@s8a4f')

# SECURITY WARNING: don't run with debug turned on in production!
DEBUG = (os.getenv('DEBUG', 'True') == 'True')

ALLOWED_HOSTS = []


# Application definition

INSTALLED_APPS = [
    'django.contrib.admin',
    'django.contrib.auth',
    'django.contrib.contenttypes',
    'django.contrib.sessions',
    'django.contrib.messages',
    'django.contrib.staticfiles',
    'behave_django',
    'interscitybus',
    'waze',
    'otp_interface',
    'bootstrap4',
    'static_pages',
]

MIDDLEWARE = [
    'django.middleware.security.SecurityMiddleware',
    'django.contrib.sessions.middleware.SessionMiddleware',
    'django.middleware.locale.LocaleMiddleware',
    'django.middleware.common.CommonMiddleware',
    'django.middleware.csrf.CsrfViewMiddleware',
    'django.contrib.auth.middleware.AuthenticationMiddleware',
    'django.contrib.messages.middleware.MessageMiddleware',
    'django.middleware.clickjacking.XFrameOptionsMiddleware',
]

ROOT_URLCONF = 'smartcities_bigdata.urls'

TEMPLATES = [
    {
        'BACKEND': 'django.template.backends.django.DjangoTemplates',
        'DIRS': [os.path.join(BASE_DIR, 'shared_templates')],
        'APP_DIRS': True,
        'OPTIONS': {
            'context_processors': [
                'django.template.context_processors.debug',
                'django.template.context_processors.request',
                'django.contrib.auth.context_processors.auth',
                'django.contrib.messages.context_processors.messages',
            ],
        },
    },
]

WSGI_APPLICATION = 'smartcities_bigdata.wsgi.application'


# Database
# https://docs.djangoproject.com/en/3.1/ref/settings/#databases

DATABASES = {
    'default': {
        'ENGINE': 'djongo',
        'NAME': 'smartcities_bigdata',
        'CLIENT': {
           'host': os.getenv('DB_HOST', 'localhost'),
        }
    }
}


# Password validation
# https://docs.djangoproject.com/en/3.1/ref/settings/#auth-password-validators

AUTH_PASSWORD_VALIDATORS = [
    {
        'NAME': 'django.contrib.auth.password_validation.UserAttributeSimilarityValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.MinimumLengthValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.CommonPasswordValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.NumericPasswordValidator',
    },
]


# Internationalization
# https://docs.djangoproject.com/en/3.1/topics/i18n/

LANGUAGE_CODE = 'en'

TIME_ZONE = 'UTC'

USE_I18N = True

USE_L10N = True

USE_TZ = True

LANGUAGES = (
    ('pt', 'Português'),
    ('en', 'English'),
    ('es', 'Español'),
)

LOCALE_PATHS = (
    os.path.join(BASE_DIR, 'locale'),
)


# Static files (CSS, JavaScript, Images)
# https://docs.djangoproject.com/en/3.1/howto/static-files/

STATIC_URL = '/static/'
STATICFILES_DIRS = [
    os.path.join(BASE_DIR, "shared_templates/static"),
]
STATIC_ROOT = os.path.join(BASE_DIR, 'static')


# SP GTFS API
# https://www.sptrans.com.br/desenvolvedores/

OLHO_VIVO_URL = 'http://api.olhovivo.sptrans.com.br/v2.1/'

# Set a valid token for production
OLHO_VIVO_TOKEN = os.getenv('OLHO_VIVO_TOKEN', 'CHANGE ME')

# Check https://docs.sentry.io/product/sentry-basics/dsn-explainer/#where-to-find-your-dsn
SENTRY_DSN = os.getenv('SENTRY_DSN', '')

# You'll need to acquire credentials at https://partnerdash.google.com/waze/start#p=start&program=CCP
WAZE_BASE_URL = os.getenv('WAZE_BASE_URL', '')
WAZE_POLYGONS = {
    'Xalapa': {
        'city': 'Xalapa',
        'points': '-97.16627,19.797331;-96.57464,19.794427;-96.57660,19.272967;-97.17500,19.276073;-97.16627,19.797331',
    },
    'Quito': {
        'city': 'Quito',
        'points': '-78.486,0.133;-78.595,-0.176;-78.648,-0.36;-78.445,-0.404;-78.25,0.114;-78.486,0.133',
    },
    'Montivideo': {
        'city': 'Montivideo',
        'points': '-56.324,-34.601;-56.45,-34.881;-55.934,-35.003;-55.39,-34.854;-56.324,-34.601',
    },
    'Sao Paulo 1': {
        'city': 'São Paulo',
        'points': '-46.89388,-23.65469;-46.8972,-23.79037;-46.32591,-23.791;-46.32865,-23.64431;-46.89388,-23.65469',
    },
    'Sao Paulo 2': {
        'city': 'São Paulo',
        'points': '-46.9344,-23.4539;-46.91986,-23.55706;-46.27304,-23.52685;-46.30119,-23.35991;-46.9344,-23.4539',
    },
    'Sao Paulo 3': {
        'city': 'São Paulo',
        'points': '-46.2656,-23.52821;-46.92789,-23.5558;-46.90063,-23.65647;-46.31814,-23.64391;-46.2656,-23.52821',
    },
}

# Open Trip Planner Hosts
OTP = {
    'sao_paulo': {
        'city': 'São Paulo',
        'url': 'http://localhost:8080',
    },
    'xalapa': {
        'city': 'Xalapa',
        'url': 'http://localhost:8081',
    },
    'lima': {
        'city': 'Lima',
        'url': 'http://localhost:8082',
    },
    'montevideo': {
        'city': 'Montevideo',
        'url': 'http://localhost:8083',
    },
}

try:
    # pylama:ignore=W:select=[W611, W401]
    from .local_settings import *
except ImportError:
    pass

if SENTRY_DSN:
    import sentry_sdk
    from sentry_sdk.integrations.django import DjangoIntegration

    sentry_sdk.init(
        dsn=SENTRY_DSN,
        integrations=[DjangoIntegration()]
    )
